DataSource (Java Platform SE 8 )
Keywords: javax.sql.DataSource interface
Date: 2026-04-22

compact2, compact3
javax.sql

## Interface DataSource

- All Superinterfaces:
    CommonDataSource, Wrapper

      public interface DataSource
      extends CommonDataSource, Wrapper

  A factory for connections to the physical data source that this `DataSource` object represents. An alternative to the `DriverManager` facility, a `DataSource` object is the preferred means of getting a connection. An object that implements the `DataSource` interface will typically be registered with a naming service based on the Java™ Naming and Directory (JNDI) API.

  The `DataSource` interface is implemented by a driver vendor. There are three types of implementations:

  1. Basic implementation -- produces a standard `Connection` object
  2. Connection pooling implementation -- produces a `Connection` object that will automatically participate in connection pooling. This implementation works with a middle-tier connection pooling manager.
  3. Distributed transaction implementation -- produces a `Connection` object that may be used for distributed transactions and almost always participates in connection pooling. This implementation works with a middle-tier transaction manager and almost always with a connection pooling manager.

  A `DataSource` object has properties that can be modified when necessary. For example, if the data source is moved to a different server, the property for the server can be changed. The benefit is that because the data source's properties can be changed, any code accessing that data source does not need to be changed.

  A driver that is accessed via a `DataSource` object does not register itself with the `DriverManager`. Rather, a `DataSource` object is retrieved though a lookup operation and then used to create a `Connection` object. With a basic implementation, the connection obtained through a `DataSource` object is identical to a connection obtained through the `DriverManager` facility.

  An implementation of `DataSource` must include a public no-arg constructor.

  Since:
    1.4

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `Connection` | `getConnection()` Attempts to establish a connection with the data source that this `DataSource` object represents.
    `Connection` | `getConnection(String username, String password)` Attempts to establish a connection with the data source that this `DataSource` object represents.

    - ### Methods inherited from interface javax.sql.CommonDataSource

      `getLoginTimeout, getLogWriter, getParentLogger, setLoginTimeout, setLogWriter`

    - ### Methods inherited from interface java.sql.Wrapper

      `isWrapperFor, unwrap`

- - ### Method Detail

    - #### getConnection

          Connection getConnection()
                            throws SQLException

      Attempts to establish a connection with the data source that this `DataSource` object represents.

      Returns:
        a connection to the data source
      Throws:
        `SQLException` - if a database access error occurs
        `SQLTimeoutException` - when the driver has determined that the timeout value specified by the `setLoginTimeout` method has been exceeded and has at least tried to cancel the current database connection attempt

    - #### getConnection

          Connection getConnection(String username,
                                   String password)
                            throws SQLException

      Attempts to establish a connection with the data source that this `DataSource` object represents.

      Parameters:
        `username` - the database user on whose behalf the connection is being made
        `password` - the user's password
      Returns:
        a connection to the data source
      Throws:
        `SQLException` - if a database access error occurs
        `SQLTimeoutException` - when the driver has determined that the timeout value specified by the `setLoginTimeout` method has been exceeded and has at least tried to cancel the current database connection attempt
      Since:
        1.4

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.